//+------------------------------------------------------------------+
//|                                                       Grider.mq4 |
//|                                                        Scriptong |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Scriptong"
#property link      "scriptong@mail.ru"

//     :
//    1) 0 - 9999 -       (0 - 9999)
//    2) 10 000 -  Max (int) -  , . . MagicNumber     2 147 483

//---- input parameters
extern double    Lots              = 0.01;
extern int       Step              = 120;
extern int       MaxOrdersOnSide   = 2;
extern string    OpenOrderSound = "ok.wav";
extern int       MagicNumber = 4569;
extern double    MaxEquity =1100.0;
extern int       Orderdel=2; 

bool Activate, FreeMarginAlert, FatalError,OrderDelet;
double Tick, Spread, StopLevel, MinLot, MaxLot, LotStep;
double HighBuyAP, LowBuyAP, HighBuyBP, LowBuyBP, FreezeLevel;
int    HighBuyAPTicket, LowBuyAPTicket, 
       HighBuyBPTicket, LowBuyBPTicket, 
       CountBuyA, CountBuyB;       

//+-------------------------------------------------------------------------------------+
//| expert initialization function                                                      |
//+-------------------------------------------------------------------------------------+
int init()
  {
   FatalError = False;
   Activate = False;
// - 1 - ==      ========================================   
   Tick = MarketInfo(Symbol(), MODE_TICKSIZE);                         //      
   Spread = ND(MarketInfo(Symbol(), MODE_SPREAD)*Point);                  //  
   StopLevel = ND(MarketInfo(Symbol(), MODE_STOPLEVEL)*Point);  //    
   FreezeLevel = ND(MarketInfo(Symbol(), MODE_FREEZELEVEL)*Point);   //  
   MinLot = MarketInfo(Symbol(), MODE_MINLOT);    //    
   MaxLot = MarketInfo(Symbol(), MODE_MAXLOT);   //    
   LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);          //    
// - 1 - ==   =============================================================

// - 2 - ==          =======   
   Lots = MathRound(Lots/LotStep)*LotStep; //     
   if(Lots < MinLot || Lots > MaxLot) //     MinLot    MaxLot
     {
      Comment(" Lots     !  !");
      return(0);
     }
// - 2 - ==   =============================================================

// - 3 - ==     ====================================   
   if (Step <= (StopLevel+Spread)/Point || Step > 9999)
     {
      Comment("  Step    ", MathCeil(StopLevel/Point),
              "   10 000 .");
      Print("  Step    ", MathCeil(StopLevel/Point),
            "   10 000 .");
      return(0);
     }
     
   if (MagicNumber > 2147483)
     {
      Comment(" MagicNumber    2 147 483.  !");
      Print(" MagicNumber    2 147 483.  !");
      return(0);
     }   

   if (MaxOrdersOnSide > 999)
     {
      Comment(" MaxOrdersOnSide    1000.  !");
      Print(" MaxOrdersOnSide    1000.  !");
      return(0);
     }   
// - 3 - ==   =============================================================
    
// - 4 - ==        =========================   
   Comment(",         ...");
   for (int i = OrdersTotal()-1; i >= 0; i--)
     if (OrderSelect(i, SELECT_BY_POS))
       if (Symbol() == OrderSymbol() && 
           MagicNumber == MathFloor(OrderMagicNumber()/10000))
         {
          if (NormalizeDouble(MathMod(MathMod(OrderMagicNumber(), 10000), 0), 10) != Step)
            if (WaitForTradeContext())
              if (!OrderDelete(OrderTicket()))
                {
                 Comment("    .   .");
                 Print("    .   .");
                 return(0);
                }
         }
   Comment("");      
// - 4 - ==   =============================================================

   Activate = True;
   OrderDelet=True;
//----
   return(0);
  }
//+-------------------------------------------------------------------------------------+
//| expert deinitialization function                                                    |
//+-------------------------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
//----
   return(0);
  }
  
//+-------------------------------------------------------------------------------------+
//|                                                |
//+-------------------------------------------------------------------------------------+
double ND(double A)
{
 return(NormalizeDouble(A, Digits));
}  

//+-------------------------------------------------------------------------------------+
//|                                                         |
//+-------------------------------------------------------------------------------------+
string ErrorToString(int Error)
{
 switch(Error)
   {
    case 2: return("  ,   ."); 
    case 5: return("    ,  ."); 
    case 6: return("   ,   ."); 
    case 64: return(" ,   .");
    case 132: return(" ."); 
    case 133: return(" ."); 
    case 149: return(" ."); 
   }
}

//+-------------------------------------------------------------------------------------+
//|   .   ,   True,  - False    |
//+-------------------------------------------------------------------------------------+  
bool WaitForTradeContext()
{
 int P = 0;
 //  ""
 while(IsTradeContextBusy() && P < 5)
   {
    P++;
    Sleep(1000);
   }
 // -------------  
 if(P == 5)
   return(False);
 return(True);    
}
  
//+-------------------------------------------------------------------------------------+
//| ""                                                         |
//|    OpenOrder            |
//| :                                                                         |
//|   0 -                                                                      |
//|   1 -                                                                 |
//|   2 -   Price                                                         |
//|   3 -   SL                                                            |
//|   4 -   TP                                                            |
//|   5 -   Lot                                                           |
//+-------------------------------------------------------------------------------------+
int OpenOrderCorrect(int Type, double Price, double SL, double TP, bool Redefinition = True)
// Redefinition -  True     
//                 False -  
{
// - 1 - ==     ====================================
 if(AccountFreeMarginCheck(Symbol(), OP_BUY, Lots) <= 0 || GetLastError() == 134) 
  {
   if(!FreeMarginAlert)
    {
     Print("    . Free Margin = ", 
           AccountFreeMargin());
     FreeMarginAlert = True;
    } 
   return(5);  
  }
 FreeMarginAlert = False;  
// - 1 - ==   =============================================================

// - 2 - ==   Price, SL  TP    ====================   

 RefreshRates();
 switch (Type)
   {
    case OP_BUY: 
                string S = "BUY"; 
                if (MathAbs(Price-Ask)/Point > 3)
                  if (Redefinition) Price = ND(Ask);
                  else              return(2);
                if (ND(TP-Bid) < StopLevel && TP != 0)
                  if (Redefinition) TP = ND(Bid+StopLevel);
                  else              return(4);
                if (ND(Bid-SL) < StopLevel)
                  if (Redefinition) SL = ND(Bid-StopLevel);
                  else              return(3);
                break;
    case OP_SELL: 
                 S = "SELL"; 
                 if (MathAbs(Price-Bid)/Point > 3)
                   if (Redefinition) Price = ND(Bid);
                   else              return(2);
                 if (ND(Ask-TP) < StopLevel) 
                   if (Redefinition) TP = ND(Ask-StopLevel);
                   else              return(4);
                 if (ND(SL-Ask) < StopLevel && SL != 0)
                   if (Redefinition) SL = ND(Ask+StopLevel);
                   else              return(3);
                 break;
    case OP_BUYSTOP: 
                    S = "BUYSTOP";
                    if (ND(Price-Ask) < StopLevel)
                      if (Redefinition) Price = ND(Ask+StopLevel);
                      else              return(2);
                    if (ND(TP-Price) < StopLevel && TP != 0)
                      if (Redefinition) TP = ND(Price+StopLevel);
                      else              return(4);
                    if (ND(Price-SL) < StopLevel)
                      if (Redefinition) SL = ND(Price-StopLevel);
                      else              return(3);
                    break;
    case OP_SELLSTOP: 
                     S = "SELLSTOP";
                     if (ND(Bid-Price) < StopLevel)
                       if (Redefinition) Price = ND(Bid-StopLevel);
                       else              return(2);
                     if (ND(Price-TP) < StopLevel)
                       if (Redefinition) TP = ND(Price-StopLevel);
                       else              return(4);
                     if (ND(SL-Price) < StopLevel && SL != 0)
                       if (Redefinition) SL = ND(Price+StopLevel);
                       else              return(3);
                     break;
    case OP_BUYLIMIT: 
                     S = "BUYLIMIT";
                     if (ND(Ask-Price) < StopLevel)
                      if (Redefinition) Price = ND(Ask-StopLevel);
                      else              return(2);
                     if (ND(TP-Price) < StopLevel && TP != 0)
                       if (Redefinition) TP = ND(Price+StopLevel);
                       else              return(4);
                     if (ND(Price-SL) < StopLevel)
                       if (Redefinition) SL = ND(Price-StopLevel);
                       else              return(3);
                     break;
    case OP_SELLLIMIT: 
                     S = "SELLLIMIT";
                     if (ND(Price - Bid) < StopLevel) 
                       if (Redefinition) Price = ND(Bid+StopLevel);
                       else              return(2);
                     if (ND(Price-TP) < StopLevel)
                       if (Redefinition) TP = ND(Price-StopLevel);
                       else              return(4);
                     if (ND(SL-Price) < StopLevel && SL != 0)
                       if (Redefinition) SL = ND(Price+StopLevel);
                       else              return(3);
                     break;
   }
// - 2 - ==   =============================================================
 
// - 3 - ==       =================================   
 if(WaitForTradeContext())  //    
   {  
    Comment("     ", S, " ...");  
    int ticket=OrderSend(Symbol(), Type, Lots, Price, 3, 
               SL, TP, NULL, 10000*MagicNumber+Step, 0);//  
    //     
    if(ticket<0)
      {
       int Error = GetLastError();
       if(Error == 2 || Error == 5 || Error == 6 || Error == 64 
          || Error == 132 || Error == 133 || Error == 149)     //   
         {
          Comment("     . . "+
                   ErrorToString(Error)+"  !");
          FatalError = True;
         }
        else 
         Comment("   ", S, ": ", Error);       //  
       return(1);
      }
    // ---------------------------------------------
    
    //      
    Comment(" ", S, "  !"); 
    PlaySound(OpenOrderSound); 
    return(0); 
    // ------------------------
   }
  else
   {
    Comment("     !");
    return(1);  
   } 
// - 3 - ==   =============================================================
   
}

//+-------------------------------------------------------------------------------------+
//|                                                               |
//+-------------------------------------------------------------------------------------+
void OwnOrders()
{
// - 1 - ==    ===================================================
 HighBuyAP = 0; LowBuyAP = 0;//     BUY,    
 HighBuyBP = 0; LowBuyBP = 0;//     BUY,     
 
 
 HighBuyAPTicket = -1; LowBuyAPTicket = -1;    //     BUY  
 HighBuyBPTicket = -1; LowBuyBPTicket = -1;    //     BUY  
 
 CountBuyA = 0; CountBuyB = 0;                         //  BUY    
// - 1 - ==   =============================================================
 
// - 2 - ==        ==================================
 for (int i = 0; i < OrdersTotal(); i++)
   if (OrderSelect(i, SELECT_BY_POS))
     if (Symbol() == OrderSymbol() && 
         MagicNumber == MathFloor(OrderMagicNumber()/10000))
       {
        int Type = MathMod(OrderType(), 2);
        // - 2.1 - ===================   BUY ===========================
        if (Type == 0)                                                  
          {
           if (OrderOpenPrice() > Ask)                   // ,    
             {
              CountBuyA++;
              if (HighBuyAP < OrderOpenPrice())
                {
                 HighBuyAP = OrderOpenPrice();
                 HighBuyAPTicket = OrderTicket();
                }
              if (LowBuyAP > OrderOpenPrice() || LowBuyAP == 0)
                {
                 LowBuyAP = OrderOpenPrice();
                 LowBuyAPTicket = OrderTicket();
                }
             } 
            else                                         // ,    
             if (OrderOpenPrice() < Ask)
               {
                CountBuyB++;
                if (HighBuyBP < OrderOpenPrice())
                  {
                   HighBuyBP = OrderOpenPrice();
                   HighBuyBPTicket = OrderTicket();
                  }
                if (LowBuyBP > OrderOpenPrice() || LowBuyBP == 0)
                  {
                   LowBuyBP = OrderOpenPrice();
                   LowBuyBPTicket = OrderTicket();
                  }
               } 
          }
        // - 2.1 - ===================   ==================================
       }
// - 2 - ==   =============================================================
}

//+-------------------------------------------------------------------------------------+
//|                                                         |
//+-------------------------------------------------------------------------------------+
void SetOrModifyOrders()
{
 RefreshRates();
// - 1 -  ========================================   BUY =========================
    // - 1.1 - =============       ========================
    if (CountBuyA < MaxOrdersOnSide)
      {//     ,    :
       //   1)     -    
       //   2)     ,     -    
       //      BUY,    ( HighBuyBP + Step)
       //   3)           -   
       //      
       //   4)           -    
       //      
       double Price = 0;
       if (LowBuyAP-Ask > Step*Tick && LowBuyAP-Step*Tick-StopLevel > Ask)   //  
         Price = LowBuyAP-Step*Tick;//      BUY  3
        else
         if (LowBuyAP == 0)                                  //     
           {
            if (HighBuyBP != 0)                                   //    
              {
               if (HighBuyBP + Step*Tick - StopLevel > Ask)//   StopLevel
                 Price = HighBuyBP+Step*Tick;     //      2
                else
                 Price = HighBuyBP+2*Step*Tick;      //  -     2
              } 
             else                        //     -    
              Price = Ask + Step*Tick;                                      //  1
           }
          else              //           
           Price = HighBuyAP + Step*Tick;            //     4
       if (Price != 0 && Price - StopLevel > Ask)
         {
          OpenOrderCorrect(OP_BUYSTOP, ND(Price), 0, ND(Price+Step*Tick-Spread), False);
          return(0);
         } 
      }
    // - 1.1 - ==========================   ===============================
    
    // - 1.2 - =============       =======================
    if (CountBuyA >= MaxOrdersOnSide)
      {//     :
       //   1)    ,   
       //   2)            BuyStop
       if (CountBuyA > MaxOrdersOnSide+1)                          //   
         if (OrderSelect(HighBuyAPTicket, SELECT_BY_TICKET))//   
           if (OrderType() == OP_BUYSTOP)   //   ,    1
             if (WaitForTradeContext())
               if (OrderOpenPrice() - Ask > FreezeLevel)
                 {
                  OrderDelete(OrderTicket());
                  return(0);
                 }
       if (LowBuyAP-Ask > Step*Tick && LowBuyAP-Step*Tick-StopLevel > Ask)   //  
         {                          //      BUY  2
          Price = LowBuyAP-Step*Tick;
          OpenOrderCorrect(OP_BUYSTOP, ND(Price), 0, ND(Price+Step*Tick-Spread), False);
          return(0);
         }
      }         
    // - 1.2 - =============      =============================
    
    // - 1.3 - =============       ========================
    if (CountBuyB < MaxOrdersOnSide)
      {//     ,    :
       //   1)     -       Step 
       //   2)     ,     -    
       //      BUY,    ( LowBuyAP - Step)
       //   3)           -   
       //       ( HighBuyBP + Step)
       //   4)           -    
       //       ( LowBuyBP - Step)
       Price = 0;
       if (Ask-HighBuyBP > Step*Tick && Ask-HighBuyBP-Step*Tick > StopLevel  //  
           && HighBuyBP > 0)                                         //     
         Price = HighBuyBP+Step*Tick; //      BUY . 3
        else
         if (HighBuyBP == 0)                                 //     
           {
            if (LowBuyAP != 0)                                    //    
              {
               int i = 1;
               while (Ask - Price <= StopLevel || Price == 0)
                 {
                  Price = LowBuyAP-i*Step*Tick;                             //  2
                  i++;
                 } 
              } 
             else                        //     -    
              Price = Ask - Step*Tick;                                      //  1
           }
          else             //           
           Price = LowBuyBP - Step*Tick;             //     4
       if (Price != 0 && Ask - Price > StopLevel)
         {
          OpenOrderCorrect(OP_BUYLIMIT, ND(Price), 0, ND(Price+Step*Tick-Spread), False);
          return(0);
         } 
      }
    // - 1.3 - ==========================   ===============================
    
    // - 1.4 - =============       =======================
    if (CountBuyB >= MaxOrdersOnSide)
      {//     :
       //   1)    ,   
       //   2)        BuyLimit
       if (CountBuyB > MaxOrdersOnSide+1)
         if (OrderSelect(LowBuyBPTicket, SELECT_BY_TICKET)) //    
           if (OrderType() == OP_BUYLIMIT) //    (    
             if (WaitForTradeContext())                             // ),  
               if (Ask - OrderOpenPrice() > FreezeLevel)
                 {
                  OrderDelete(OrderTicket());
                  return(0);
                 }
       if (Ask-HighBuyBP > Step*Tick && Ask-HighBuyBP-Step*Tick > StopLevel) //  
         {                         //      BUY  2
          Price = HighBuyBP+Step*Tick;
          OpenOrderCorrect(OP_BUYLIMIT, ND(Price), 0, ND(Price+Step*Tick-Spread), False);
          return(0);
         }
      }         
    // - 1.4 - =============      =============================
// - 1 -  ===========================     BUY ======================

}
 bool DeleteMinusOrders()
 {
 int kol=OrdersTotal();
 double Massiv[][2];
 ArrayResize(Massiv,kol);
 for(int cnt=0;cnt<kol;cnt++)
   {
   OrderSelect(cnt,SELECT_BY_POS);
   Massiv[cnt][0]=OrderProfit();
   Massiv[cnt][1]=OrderTicket();
   
   }
 ArraySort(Massiv);
 for (cnt=0;cnt< Orderdel;cnt++)
   {
   
   int tic=Massiv[cnt][1];
   if(OrderSelect(tic,SELECT_BY_TICKET)&&OrderType()<2)
      {      
      OrderClose(tic,OrderLots(),OrderClosePrice(),3);      
      }
   } 
   return (true);
 } 
//+-------------------------------------------------------------------------------------+
//|  START                                                               |
//+-------------------------------------------------------------------------------------+
int start()
  {
  if(AccountEquity()>MaxEquity&&OrderDelet)
  if(DeleteMinusOrders())OrderDelet=false;
// - 1 -  ==    ? ===========================================
   if (!Activate || FatalError)             //   ,  
    return(0);           //  init         
// - 1 -  ==   ============================================================
     
// - 2 - ==      ========================================
   Spread = ND(MarketInfo(Symbol(), MODE_SPREAD)*Point);                 //  
   StopLevel = ND(MarketInfo(Symbol(), MODE_STOPLEVEL)*Point);  //    
   FreezeLevel = ND(MarketInfo(Symbol(), MODE_FREEZELEVEL)*Point);   //  
// - 2 -  ==   ============================================================

// - 3 - ==    =======================================================
   OwnOrders();
// - 3 -  ==   ============================================================
   
// - 4 - ==     =============================================
   SetOrModifyOrders();
// - 4 -  ==   ============================================================

   return(0);
  }
//+------------------------------------------------------------------+